<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Ger22000ApresentacaoProdutoController extends \Zeedhi\Framework\Controller\Report {
    protected $environment;
    protected $birtStrategy;
    protected $reportService;

    public function __construct($reportService, $birtStrategy, $environment) {
    	$this->reportService = $reportService;
    	$this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
    }

    protected $reportMapping = array (
    "GER22000" =>
        array (
            "strategy" => "BIRT",
            "parameterMapping" =>
            array (
                'CDPICTPROD'   => 'P_CDPICTPROD',
                "NRORG"        => "P_NRORG"
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            
            $row = $request->getRow();
            $row["NRORG"] = $this->environment->getNrOrg();
            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
} 
